﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private provider As FileProvider
	Dim Panel1 As Panel
	Private ion As Object
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	provider.Initialize
End Sub

Private Sub PanelToPdf(Panel As B4XView, FileName As String)
	Dim pdf As PdfDocument
	pdf.Initialize
	pdf.StartPage(595, 842) 'A4 size
	Dim bmp As B4XBitmap = Panel.Snapshot
	Dim dest As Rect
	dest.Initialize(10, 10, 0, 0)
	dest.Width = bmp.Width / bmp.Scale
	dest.Height = bmp.Height / bmp.Scale
	pdf.Canvas.DrawBitmap(bmp, Null, dest)
	pdf.FinishPage
	Dim out As OutputStream = File.OpenOutput(provider.SharedFolder, FileName, False)
	pdf.WriteToStream(out)
	out.Close
	pdf.Close
	
		
''	Sleep(15000)
'	File.WriteString(File.DirInternal, "1.pdf", "pdf")
'	Wait For (SaveFile(File.OpenInput(File.DirInternal, "1.pdf"), "application/octet-stream", "1.pdf")) Complete (Success As Boolean)
'	Log("File saved successfully? " & Success)
	
	
	Dim in As Intent
	in.Initialize(in.ACTION_VIEW, "")
	provider.SetFileUriAsIntentData(in, FileName)
	in.SetType("application/pdf")
	StartActivity(in)
	
	
	Sleep(15000)
	File.WriteString(File.DirInternal, "1.pdf", "pdf")
	Wait For (SaveFile(File.OpenInput(File.DirInternal, "1.pdf"), "application/octet-stream", "1.pdf")) Complete (Success As Boolean)
	Log("File saved successfully? " & Success)
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	
	
	
	
	PanelToPdf(Root, "1.pdf")

	
End Sub

Sub SaveFile (Source As InputStream, MimeType As String, Title As String) As ResumableSub
	Dim intent As Intent
	intent.Initialize("android.intent.action.CREATE_DOCUMENT", "")
	intent.AddCategory("android.intent.category.OPENABLE")
	intent.PutExtra("android.intent.extra.TITLE", Title)
	intent.SetType(MimeType)
	StartActivityForResult(intent)
	Wait For ion_Event (MethodName As String, Args() As Object)
	If -1 = Args(0) Then 'resultCode = RESULT_OK
		Dim result As Intent = Args(1)
		Dim jo As JavaObject = result
		Dim ctxt As JavaObject
		Dim out As OutputStream = ctxt.InitializeContext.RunMethodJO("getContentResolver", Null).RunMethod("openOutputStream", Array(jo.RunMethod("getData", Null)))
		File.Copy2(Source, out)
		out.Close
		Return True
	End If
	Return False
End Sub

Sub StartActivityForResult(i As Intent)
	Dim jo As JavaObject = GetBA
	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
	jo.RunMethod("startActivityForResult", Array(ion, i))
End Sub

Sub GetBA As Object
	Dim jo As JavaObject = Me
	Return jo.RunMethod("getBA", Null)
End Sub
